﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace CameraMoveExample
{
    class Camera
    {
        public Vector2 Position { get; set; }
        public float Rotation { get; set; }
        public float Zoom { get; set; }

        public Vector2 DesiredPosition { get; set; }
        public float DesiredRotation { get; set; }
        public float LinearSpeed { get; set; }
        public float AngularSpeed { get; set; }

        private SpriteBatch mSpriteBatch;

        private Random r;

        public Camera(SpriteBatch sb)
        {
            mSpriteBatch = sb;
            Position = new Vector2(Game1.SCREEN_WIDTH/ 2, Game1.SCREEN_HEIGHT/ 2);
            DesiredPosition = Position;
            DesiredRotation = Rotation;
            Rotation = 0.0f;
            Zoom = 1.0f;
            LinearSpeed = 100;
            AngularSpeed = 0.1f;
            r = new Random();
        }

        public void Begin()
        {
            mSpriteBatch.Begin();
        }

        public void End()
        {
            mSpriteBatch.End();
        }

        public void Shake(float time)
        {
            // TODO 5a:
            //   Fill me in to implement shake
            //     HINT:  This method will likely just set a value of time remaining to shake
            //            Actual shaking will occur in either Update or Draw
        }

        public void Update(GameTime gameTime)
        {
            // TODO 4:
            //   Instead of snapping immediatley to desired position and rotation,
            //   move camera using LinearSpeed and AngularSpeed
            Position = DesiredPosition;
            Rotation = DesiredRotation;

            // TODO 5b:
            //  Code to implement shake update (if necessary)
        }

        public void Draw(WorldObject obj)
        {

            // TODO 1:  
            //      Update objPosInCameraSpace so that it is the actual position in camera space, not just
            //      the postion in world space
            Vector2 objPosInCameraSpace = obj.PositionInWorldSpace;

            // TODO 2:  
            //      Update objPosInScreenSpace so that it is the actual position in screen space, not just
            //      the postion in camera space
            Vector2 objPosInScreenSpace = objPosInCameraSpace;

            // TODO 3:  
            //      Update rotationInScreenSpace so that it is the actual rotation in screen space, not just
            //      the rotation in world space space
            float rotationInScreenSpace = obj.RotationInWorldSpace;

            // TODO 5c:
            //  Code to implement any changes for shake (if necessary)

            mSpriteBatch.Draw(obj.Texture, objPosInScreenSpace, null, Color.White, rotationInScreenSpace, obj.TextureOrigin, Zoom, SpriteEffects.None, 0);

        }
    }
}
